/**
 * The run-time representation of a function (that is, a
 * procedure). This is a value that can be applied to another value
 * (the function's argument), so as to compute yet another value (the
 * function's result).
 */
public interface Function {

    /**
     * Apply this function to a specified argument value.
     * @param argument the argument value
     * @return the result value from the function application.
     */
    Object apply(Object argument);
}